/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftOutstandingPlCache implements org.apache.thrift.TBase<ThriftOutstandingPlCache, ThriftOutstandingPlCache._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftOutstandingPlCache> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftOutstandingPlCache");

  private static final org.apache.thrift.protocol.TField USER_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("userId", org.apache.thrift.protocol.TType.I64, (short)1);
  private static final org.apache.thrift.protocol.TField PROFIT_LOSS_FIELD_DESC = new org.apache.thrift.protocol.TField("profitLoss", org.apache.thrift.protocol.TType.DOUBLE, (short)2);
  private static final org.apache.thrift.protocol.TField OUT_STANDING_FIELD_DESC = new org.apache.thrift.protocol.TField("outStanding", org.apache.thrift.protocol.TType.DOUBLE, (short)3);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftOutstandingPlCacheStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftOutstandingPlCacheTupleSchemeFactory());
  }

  public long userId; // optional
  public double profitLoss; // optional
  public double outStanding; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    USER_ID((short)1, "userId"),
    PROFIT_LOSS((short)2, "profitLoss"),
    OUT_STANDING((short)3, "outStanding");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // USER_ID
          return USER_ID;
        case 2: // PROFIT_LOSS
          return PROFIT_LOSS;
        case 3: // OUT_STANDING
          return OUT_STANDING;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __USERID_ISSET_ID = 0;
  private static final int __PROFITLOSS_ISSET_ID = 1;
  private static final int __OUTSTANDING_ISSET_ID = 2;
  private byte __isset_bitfield = 0;
  private static final _Fields optionals[] = {_Fields.USER_ID,_Fields.PROFIT_LOSS,_Fields.OUT_STANDING};
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.USER_ID, new org.apache.thrift.meta_data.FieldMetaData("userId", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.PROFIT_LOSS, new org.apache.thrift.meta_data.FieldMetaData("profitLoss", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.OUT_STANDING, new org.apache.thrift.meta_data.FieldMetaData("outStanding", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftOutstandingPlCache.class, metaDataMap);
  }

  public ThriftOutstandingPlCache() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftOutstandingPlCache(ThriftOutstandingPlCache other) {
    __isset_bitfield = other.__isset_bitfield;
    this.userId = other.userId;
    this.profitLoss = other.profitLoss;
    this.outStanding = other.outStanding;
  }

  public ThriftOutstandingPlCache deepCopy() {
    return new ThriftOutstandingPlCache(this);
  }

  @Override
  public void clear() {
    setUserIdIsSet(false);
    this.userId = 0;
    setProfitLossIsSet(false);
    this.profitLoss = 0.0;
    setOutStandingIsSet(false);
    this.outStanding = 0.0;
  }

  public long getUserId() {
    return this.userId;
  }

  public ThriftOutstandingPlCache setUserId(long userId) {
    this.userId = userId;
    setUserIdIsSet(true);
    return this;
  }

  public void unsetUserId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  /** Returns true if field userId is set (has been assigned a value) and false otherwise */
  public boolean isSetUserId() {
    return EncodingUtils.testBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  public void setUserIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __USERID_ISSET_ID, value);
  }

  public double getProfitLoss() {
    return this.profitLoss;
  }

  public ThriftOutstandingPlCache setProfitLoss(double profitLoss) {
    this.profitLoss = profitLoss;
    setProfitLossIsSet(true);
    return this;
  }

  public void unsetProfitLoss() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __PROFITLOSS_ISSET_ID);
  }

  /** Returns true if field profitLoss is set (has been assigned a value) and false otherwise */
  public boolean isSetProfitLoss() {
    return EncodingUtils.testBit(__isset_bitfield, __PROFITLOSS_ISSET_ID);
  }

  public void setProfitLossIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __PROFITLOSS_ISSET_ID, value);
  }

  public double getOutStanding() {
    return this.outStanding;
  }

  public ThriftOutstandingPlCache setOutStanding(double outStanding) {
    this.outStanding = outStanding;
    setOutStandingIsSet(true);
    return this;
  }

  public void unsetOutStanding() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __OUTSTANDING_ISSET_ID);
  }

  /** Returns true if field outStanding is set (has been assigned a value) and false otherwise */
  public boolean isSetOutStanding() {
    return EncodingUtils.testBit(__isset_bitfield, __OUTSTANDING_ISSET_ID);
  }

  public void setOutStandingIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __OUTSTANDING_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case USER_ID:
      if (value == null) {
        unsetUserId();
      } else {
        setUserId((Long)value);
      }
      break;

    case PROFIT_LOSS:
      if (value == null) {
        unsetProfitLoss();
      } else {
        setProfitLoss((Double)value);
      }
      break;

    case OUT_STANDING:
      if (value == null) {
        unsetOutStanding();
      } else {
        setOutStanding((Double)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case USER_ID:
      return Long.valueOf(getUserId());

    case PROFIT_LOSS:
      return Double.valueOf(getProfitLoss());

    case OUT_STANDING:
      return Double.valueOf(getOutStanding());

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case USER_ID:
      return isSetUserId();
    case PROFIT_LOSS:
      return isSetProfitLoss();
    case OUT_STANDING:
      return isSetOutStanding();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftOutstandingPlCache)
      return this.equals((ThriftOutstandingPlCache)that);
    return false;
  }

  public boolean equals(ThriftOutstandingPlCache that) {
    if (that == null)
      return false;

    boolean this_present_userId = true && this.isSetUserId();
    boolean that_present_userId = true && that.isSetUserId();
    if (this_present_userId || that_present_userId) {
      if (!(this_present_userId && that_present_userId))
        return false;
      if (this.userId != that.userId)
        return false;
    }

    boolean this_present_profitLoss = true && this.isSetProfitLoss();
    boolean that_present_profitLoss = true && that.isSetProfitLoss();
    if (this_present_profitLoss || that_present_profitLoss) {
      if (!(this_present_profitLoss && that_present_profitLoss))
        return false;
      if (this.profitLoss != that.profitLoss)
        return false;
    }

    boolean this_present_outStanding = true && this.isSetOutStanding();
    boolean that_present_outStanding = true && that.isSetOutStanding();
    if (this_present_outStanding || that_present_outStanding) {
      if (!(this_present_outStanding && that_present_outStanding))
        return false;
      if (this.outStanding != that.outStanding)
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_userId = true && (isSetUserId());
    list.add(present_userId);
    if (present_userId)
      list.add(userId);

    boolean present_profitLoss = true && (isSetProfitLoss());
    list.add(present_profitLoss);
    if (present_profitLoss)
      list.add(profitLoss);

    boolean present_outStanding = true && (isSetOutStanding());
    list.add(present_outStanding);
    if (present_outStanding)
      list.add(outStanding);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftOutstandingPlCache other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetUserId()).compareTo(other.isSetUserId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUserId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.userId, other.userId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetProfitLoss()).compareTo(other.isSetProfitLoss());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetProfitLoss()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.profitLoss, other.profitLoss);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetOutStanding()).compareTo(other.isSetOutStanding());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetOutStanding()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.outStanding, other.outStanding);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftOutstandingPlCache(");
    boolean first = true;

    if (isSetUserId()) {
      sb.append("userId:");
      sb.append(this.userId);
      first = false;
    }
    if (isSetProfitLoss()) {
      if (!first) sb.append(", ");
      sb.append("profitLoss:");
      sb.append(this.profitLoss);
      first = false;
    }
    if (isSetOutStanding()) {
      if (!first) sb.append(", ");
      sb.append("outStanding:");
      sb.append(this.outStanding);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftOutstandingPlCacheStandardSchemeFactory implements SchemeFactory {
    public ThriftOutstandingPlCacheStandardScheme getScheme() {
      return new ThriftOutstandingPlCacheStandardScheme();
    }
  }

  private static class ThriftOutstandingPlCacheStandardScheme extends StandardScheme<ThriftOutstandingPlCache> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftOutstandingPlCache struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // USER_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.userId = iprot.readI64();
              struct.setUserIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // PROFIT_LOSS
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.profitLoss = iprot.readDouble();
              struct.setProfitLossIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // OUT_STANDING
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.outStanding = iprot.readDouble();
              struct.setOutStandingIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftOutstandingPlCache struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.isSetUserId()) {
        oprot.writeFieldBegin(USER_ID_FIELD_DESC);
        oprot.writeI64(struct.userId);
        oprot.writeFieldEnd();
      }
      if (struct.isSetProfitLoss()) {
        oprot.writeFieldBegin(PROFIT_LOSS_FIELD_DESC);
        oprot.writeDouble(struct.profitLoss);
        oprot.writeFieldEnd();
      }
      if (struct.isSetOutStanding()) {
        oprot.writeFieldBegin(OUT_STANDING_FIELD_DESC);
        oprot.writeDouble(struct.outStanding);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftOutstandingPlCacheTupleSchemeFactory implements SchemeFactory {
    public ThriftOutstandingPlCacheTupleScheme getScheme() {
      return new ThriftOutstandingPlCacheTupleScheme();
    }
  }

  private static class ThriftOutstandingPlCacheTupleScheme extends TupleScheme<ThriftOutstandingPlCache> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftOutstandingPlCache struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      BitSet optionals = new BitSet();
      if (struct.isSetUserId()) {
        optionals.set(0);
      }
      if (struct.isSetProfitLoss()) {
        optionals.set(1);
      }
      if (struct.isSetOutStanding()) {
        optionals.set(2);
      }
      oprot.writeBitSet(optionals, 3);
      if (struct.isSetUserId()) {
        oprot.writeI64(struct.userId);
      }
      if (struct.isSetProfitLoss()) {
        oprot.writeDouble(struct.profitLoss);
      }
      if (struct.isSetOutStanding()) {
        oprot.writeDouble(struct.outStanding);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftOutstandingPlCache struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      BitSet incoming = iprot.readBitSet(3);
      if (incoming.get(0)) {
        struct.userId = iprot.readI64();
        struct.setUserIdIsSet(true);
      }
      if (incoming.get(1)) {
        struct.profitLoss = iprot.readDouble();
        struct.setProfitLossIsSet(true);
      }
      if (incoming.get(2)) {
        struct.outStanding = iprot.readDouble();
        struct.setOutStandingIsSet(true);
      }
    }
  }

}

